import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

/* eslint handle-callback-err: "off" */
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import AbTestToggle from '@s-ui/abtesting-toggle';
import OptimizelyX from './optimizely-x';

var AbTestOptimizelyXExperiment =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(AbTestOptimizelyXExperiment, _Component);

  function AbTestOptimizelyXExperiment() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      variation: null
    };
    return _this;
  }

  var _proto = AbTestOptimizelyXExperiment.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this._activationHandler = function (variation) {
      return _this2.setState({
        variation: variation
      });
    };

    OptimizelyX.addActivationListener(this.props.experimentId, this._activationHandler);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    OptimizelyX.removeActivationListener(this.props.experimentId, this._activationHandler);
  };

  _proto.render = function render() {
    return React.createElement(AbTestToggle, {
      variation: this.state.variation
    }, this.props.children);
  };

  return AbTestOptimizelyXExperiment;
}(Component);

AbTestOptimizelyXExperiment.displayName = 'AbTestOptimizelyXExperiment';
export default AbTestOptimizelyXExperiment;